(*****************************************************************)
(*                                                               *)
(*  ASDL to Caml translator -- support library                   *)
(*  Copyright (c) 2000 by Dmitry Lomov (dsl@tepkom.ru)           *)
(*  Distributed under GNU Library Public License                 *)
(*                                                               *)
(*****************************************************************)

(* $Id: asdlBase.mli,v 1.1.1.1 2000/12/05 09:06:52 dsl Exp $ *)

type identifier = Identifier.t

val write_int : int -> out_channel -> unit
val write_tag : int -> out_channel -> unit
val write_string : string -> out_channel -> unit
val write_identifier : identifier -> out_channel -> unit

val read_int : in_channel -> int
val read_tag : in_channel -> int
val read_string : in_channel -> string
val read_identifier : in_channel -> identifier

val write_list : ('a -> out_channel -> unit) -> 'a list -> out_channel -> unit
val read_list : (in_channel -> 'a) -> in_channel -> 'a list

val write_option : ('a -> out_channel -> unit) -> 'a option -> 
  out_channel -> unit
val read_option : (in_channel -> 'a) -> in_channel -> 'a option

val die : unit -> 'a

exception PicklerError
