(*****************************************************************)
(*                                                               *)
(*  ASDL to Caml translator                                      *)
(*  Copyright (c) 2000 by Dmitry Lomov (dsl@tepkom.ru)           *)
(*  Distributed under GNU Public License                         *)
(*                                                               *)
(*****************************************************************)

(* $Id: params.ml,v 1.1.1.1 2000/12/05 09:06:52 dsl Exp $ *)

open Printf

type t = 
    { mutable cur_file_name : string;
      mutable separate : bool;
      mutable filenames : bool
    }

let v = { cur_file_name = ""; separate = false; filenames = false }
type error = Error | Warning

let exit_level = ref 0


let msg e m pos = 
  (match e with
    Error -> exit_level := 4
  | _ -> ());
  fprintf stderr "File \"%s\"" v.cur_file_name;
  (match pos with
    Some(line, b,e) -> fprintf stderr ", line %d, characters %d-%d\n" line b e
  | None -> fprintf stderr "\n");
  fprintf stderr "%s\n" m

let terminate () = exit !exit_level
      
